# http://www.igvita.com/2008/08/10/asynchronous-db-dbslayer-httpasynchronous-db-dbslayer-http

require 'rubygems'
require 'eventmachine'
require 'evma_httpserver'
require 'em-mysql/lib/em/mysql'

class Handler  < EventMachine::Connection
  include EventMachine::HttpServer
 	attr_accessor :db

  def process_http_request
    resp = EventMachine::DelegatedHttpResponse.new( self )
   
		EventedMysql.select("select sleep(1)") { |res|
     	resp.status = 200
     	resp.content = res
      resp.send_response
		}
		
  end
end
 
EventMachine.epoll
EventMachine::run {
	SQL = EventedMysql
	@mysql = EventedMysql.settings.update :host => 'localhost', :port => 3306, :database => 'dbslayer', :connections => 200

  EventMachine::start_server("0.0.0.0", 8083, Handler) {|conn| conn.db = @mysql}
  puts "Listening..."
}
